bool ReadSTEP(const std::string &u8path)
{
    static std::mutex mtx;

   // Read all shapes
   // can't run concurrently
   mtx.lock();
   STEPControl_Controller::Init();
   Interface_Static::SetIVal("read_precision_mode", 1);
   Interface_Static::SetRVal("read_precision_val", 1e-6);
   STEPControl_Reader reader;
   if (reader.WS()->Protocol().IsNull())
       reader.WS()->SetProtocol(new StepAP214_Protocol);
   int it = reader.ReadFile(u8path.c_str());
   if (it != IFSelect_RetDone){
       qDebug("不能读取");
       mtx.unlock();
       return false;
   }
   Handle(TColStd_HSequenceOfTransient) list = reader.GiveList();
   std::cout << list->Size() << std::endl;
   {
      TColStd_SequenceOfAsciiString s1,s2,s3;
      reader.FileUnits(s1,s2,s3);
      if (s1.Size() == 1) {
          if (QString(s1.First().ToCString()).compare("millimetre", Qt::CaseInsensitive) == 0)
              Interface_Static::SetCVal("xstep.cascade.unit", "MM");
          else if (QString(s1.First().ToCString()).compare("centimetre", Qt::CaseInsensitive) == 0)
              Interface_Static::SetCVal("xstep.cascade.unit", "CM");
          else if (QString(s1.First().ToCString()).compare("kilometre", Qt::CaseInsensitive) == 0)
              Interface_Static::SetCVal("xstep.cascade.unit", "KM");
          else
             Interface_Static::SetCVal("xstep.cascade.unit", "M");
      }

      else {
          Interface_Static::SetCVal("xstep.cascade.unit", "M");
      }
   }
   mtx.unlock();

   reader.TransferRoots();
   auto shape = reader.OneShape();
   Handle(AIS_Shape) aisShape = new AIS_Shape(shape);
   m_context->Display(aisShape, Standard_True);
   fitAll();
   return true;
}

void fitAll()
{
    m_view->FitAll(0.01, false);
    m_view->ZFitAll(0.01);
    m_view->Redraw();

}